package com.ubsidi.epos_2021.merchant.fragments;

import android.app.TimePickerDialog;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.widget.SwitchCompat;

import com.androidnetworking.AndroidNetworking;
import com.androidnetworking.error.ANError;
import com.androidnetworking.interfaces.JSONObjectRequestListener;
import com.androidnetworking.interfaces.ParsedRequestListener;
import com.google.android.material.button.MaterialButton;
import com.google.android.material.chip.Chip;
import com.ubsidi.R;
import com.ubsidi.epos_2021.MyApp;
import com.ubsidi.epos_2021.base.BaseFragment;
import com.ubsidi.epos_2021.comman.CommonFunctions;
import com.ubsidi.epos_2021.models.ApiError;
import com.ubsidi.epos_2021.models.Restaurant;
import com.ubsidi.epos_2021.network.ApiEndPoints;
import com.ubsidi.epos_2021.utils.ToastUtils;

import org.json.JSONObject;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

public class SettingsDeliveryHoursFragment extends BaseFragment {

    private LinearLayout llMorningTab, llEveningTab, llMorning, llEvening;
    private LinearLayout llMondaym, llTuesdaym, llWednesdaym, llThursdaym, llFridaym, llSaturdaym, llSundaym;
    private LinearLayout llMondayClosedm, llTuesdayClosedm, llWednesdayClosedm, llThursdayClosedm, llFridayClosedm, llSaturdayClosedm, llSundayClosedm;
    private SwitchCompat swMondaym, swTuesdaym, swWednesdaym, swThursdaym, swFridaym, swSaturdaym, swSundaym;


    private TextView tvMondayFromM, tvTuesdayFromM, tvWednesdayFromM, tvThursdayFromM, tvFridayFromM, tvSaturdayFromM, tvSundayFromM;
    private TextView tvMondayToM, tvTuesdayToM, tvWednesdayToM, tvThursdayToM, tvFridayToM, tvSaturdayToM, tvSundayToM;

    private LinearLayout llMondayE, llTuesdayE, llWednesdayE, llThursdayE, llFridayE, llSaturdayE, llSundayE;
    private LinearLayout llMondayClosedE, llTuesdayClosedE, llWednesdayClosedE, llThursdayClosedE, llFridayClosedE, llSaturdayClosedE, llSundayClosedE;
    private SwitchCompat swMondayE, swTuesdayE, swWednesdayE, swThursdayE, swFridayE, swSaturdayE, swSundayE;

    private TextView tvMondayFromE, tvTuesdayFromE, tvWednesdayFromE, tvThursdayFromE, tvFridayFromE, tvSaturdayFromE, tvSundayFromE;
    private TextView tvMondayToE, tvTuesdayToE, tvWednesdayToE, tvThursdayToE, tvFridayToE, tvSaturdayToE, tvSundayToE;

    private LinearLayout llLoading;
    private Chip chipBack;
    private View vMorning, vEvening;
    private MaterialButton btnUpdate;
    private AlertDialog progressBarDialog;
    String fromDateString, toDateString;
    Date fromDate, toDate;
    Calendar fromCalendar, toCalendar;
    private Calendar today = Calendar.getInstance();
    private String fromSelectedDay, toSelectedDay;
    private Restaurant loggedInRestaurant;

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        return inflater.inflate(R.layout.fragment_delivery_hours, container, false);
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        loggedInRestaurant = MyApp.getInstance().myPreferences.getRestaurant();
        fromDate = new Date();
        toDate = new Date();

        fromCalendar = Calendar.getInstance();
        toCalendar = Calendar.getInstance();
        initViews(view);
        setListeners();
        updateViews();
    }

    private void updateViews() {
        if (loggedInRestaurant != null) {
            swMondaym.setChecked(!loggedInRestaurant.monday_status.equalsIgnoreCase("close"));
            swTuesdaym.setChecked(!loggedInRestaurant.tuesday_status.equalsIgnoreCase("close"));
            swWednesdaym.setChecked(!loggedInRestaurant.wednesday_status.equalsIgnoreCase("close"));
            swThursdaym.setChecked(!loggedInRestaurant.thursday_status.equalsIgnoreCase("close"));
            swFridaym.setChecked(!loggedInRestaurant.friday_status.equalsIgnoreCase("close"));
            swSaturdaym.setChecked(!loggedInRestaurant.saturday_status.equalsIgnoreCase("close"));
            swSundaym.setChecked(!loggedInRestaurant.sunday_status.equalsIgnoreCase("close"));

            swMondayE.setChecked(!loggedInRestaurant.monday_status.equalsIgnoreCase("close"));
            swTuesdayE.setChecked(!loggedInRestaurant.tuesday_status.equalsIgnoreCase("close"));
            swWednesdayE.setChecked(!loggedInRestaurant.wednesday_status.equalsIgnoreCase("close"));
            swThursdayE.setChecked(!loggedInRestaurant.thursday_status.equalsIgnoreCase("close"));
            swFridayE.setChecked(!loggedInRestaurant.friday_status.equalsIgnoreCase("close"));
            swSaturdayE.setChecked(!loggedInRestaurant.saturday_status.equalsIgnoreCase("close"));
            swSundayE.setChecked(!loggedInRestaurant.sunday_status.equalsIgnoreCase("close"));

            tvMondayFromM.setText(loggedInRestaurant.monday_first_opentime);
            tvMondayToM.setText(loggedInRestaurant.monday_first_closetime);

            tvTuesdayFromM.setText(loggedInRestaurant.tuesday_first_opentime);
            tvTuesdayToM.setText(loggedInRestaurant.tuesday_first_closetime);

            tvWednesdayFromM.setText(loggedInRestaurant.wednesday_first_opentime);
            tvWednesdayToM.setText(loggedInRestaurant.wednesday_first_closetime);

            tvThursdayFromM.setText(loggedInRestaurant.thursday_first_opentime);
            tvThursdayToM.setText(loggedInRestaurant.thursday_first_closetime);

            tvFridayFromM.setText(loggedInRestaurant.friday_first_opentime);
            tvFridayToM.setText(loggedInRestaurant.friday_first_closetime);

            tvSaturdayFromM.setText(loggedInRestaurant.saturday_first_opentime);
            tvSaturdayToM.setText(loggedInRestaurant.saturday_first_closetime);

            tvSundayFromM.setText(loggedInRestaurant.sunday_first_opentime);
            tvSundayToM.setText(loggedInRestaurant.sunday_first_closetime);

            //Evening time
            tvMondayFromE.setText(loggedInRestaurant.monday_second_opentime);
            tvMondayToE.setText(loggedInRestaurant.monday_second_closetime);

            tvTuesdayFromE.setText(loggedInRestaurant.tuesday_second_opentime);
            tvTuesdayToE.setText(loggedInRestaurant.tuesday_second_closetime);

            tvWednesdayFromE.setText(loggedInRestaurant.wednesday_second_opentime);
            tvWednesdayToE.setText(loggedInRestaurant.wednesday_second_closetime);

            tvThursdayFromE.setText(loggedInRestaurant.thursday_second_opentime);
            tvThursdayToE.setText(loggedInRestaurant.thursday_second_closetime);

            tvFridayFromE.setText(loggedInRestaurant.friday_second_opentime);
            tvFridayToE.setText(loggedInRestaurant.friday_second_closetime);

            tvSaturdayFromE.setText(loggedInRestaurant.saturday_second_opentime);
            tvSaturdayToE.setText(loggedInRestaurant.saturday_second_closetime);

            tvSundayFromE.setText(loggedInRestaurant.sunday_second_opentime);
            tvSundayToE.setText(loggedInRestaurant.sunday_second_closetime);

//            if(loggedInRestaurant.working_time.equalsIgnoreCase("both")){
//                llEveningTab.setVisibility(View.VISIBLE);
//                llMorningTab.setVisibility(View.VISIBLE);
//            }else if (loggedInRestaurant.working_time.equalsIgnoreCase("evening")){
//                llEveningTab.setVisibility(View.VISIBLE);
//                llMorningTab.setVisibility(View.GONE);
//            }else if (loggedInRestaurant.working_time.equalsIgnoreCase("morning")){
//                llEveningTab.setVisibility(View.VISIBLE);
//                llMorningTab.setVisibility(View.GONE);
//            }
        }
    }

    private void setListeners() {
        chipBack.setOnClickListener(v -> getActivity().onBackPressed());
        swMondaym.setOnCheckedChangeListener((buttonView, isChecked) -> {
            if (isChecked) {
                swMondaym.setText("Open");
                llMondaym.setVisibility(View.VISIBLE);
                llMondayClosedm.setVisibility(View.GONE);
                loggedInRestaurant.monday_status = "";
            } else {
                swMondaym.setText("Closed");
                llMondaym.setVisibility(View.GONE);
                llMondayClosedm.setVisibility(View.VISIBLE);
                loggedInRestaurant.monday_status = "Close";
            }
        });


        swTuesdaym.setOnCheckedChangeListener((buttonView, isChecked) -> {
            if (isChecked) {
                swTuesdaym.setText("Open");
                llTuesdaym.setVisibility(View.VISIBLE);
                llTuesdayClosedm.setVisibility(View.GONE);
                loggedInRestaurant.tuesday_status = "";
            } else {
                swTuesdaym.setText("Closed");
                llTuesdaym.setVisibility(View.GONE);
                llTuesdayClosedm.setVisibility(View.VISIBLE);
                loggedInRestaurant.tuesday_status = "Close";
            }
        });


        swWednesdaym.setOnCheckedChangeListener((buttonView, isChecked) -> {
            if (isChecked) {
                swWednesdaym.setText("Open");
                llWednesdaym.setVisibility(View.VISIBLE);
                llWednesdayClosedm.setVisibility(View.GONE);
                loggedInRestaurant.wednesday_status = "";
            } else {
                swWednesdaym.setText("Closed");
                llWednesdaym.setVisibility(View.GONE);
                llWednesdayClosedm.setVisibility(View.VISIBLE);
                loggedInRestaurant.wednesday_status = "Close";
            }
        });

        swThursdaym.setOnCheckedChangeListener((buttonView, isChecked) -> {
            if (isChecked) {
                swThursdaym.setText("Open");
                llThursdaym.setVisibility(View.VISIBLE);
                llThursdayClosedm.setVisibility(View.GONE);
                loggedInRestaurant.thursday_status = "";
            } else {
                swThursdaym.setText("Closed");
                llThursdaym.setVisibility(View.GONE);
                llThursdayClosedm.setVisibility(View.VISIBLE);
                loggedInRestaurant.thursday_status = "Close";
            }
        });

        swFridaym.setOnCheckedChangeListener((buttonView, isChecked) -> {
            if (isChecked) {
                swFridaym.setText("Open");
                llFridaym.setVisibility(View.VISIBLE);
                llFridayClosedm.setVisibility(View.GONE);
                loggedInRestaurant.friday_status = "";
            } else {
                swFridaym.setText("Closed");
                llFridaym.setVisibility(View.GONE);
                llFridayClosedm.setVisibility(View.VISIBLE);
                loggedInRestaurant.friday_status = "Close";
            }
        });

        swSaturdaym.setOnCheckedChangeListener((buttonView, isChecked) -> {
            if (isChecked) {
                swSaturdaym.setText("Open");
                llSaturdaym.setVisibility(View.VISIBLE);
                llSaturdayClosedm.setVisibility(View.GONE);
                loggedInRestaurant.saturday_status = "";
            } else {
                swSaturdaym.setText("Closed");
                llSaturdaym.setVisibility(View.GONE);
                llSaturdayClosedm.setVisibility(View.VISIBLE);
                loggedInRestaurant.saturday_status = "Close";
            }
        });

        swSundaym.setOnCheckedChangeListener((buttonView, isChecked) -> {
            if (isChecked) {
                swSundaym.setText("Open");
                llSundaym.setVisibility(View.VISIBLE);
                llSundayClosedm.setVisibility(View.GONE);
                loggedInRestaurant.sunday_status = "Close";
            } else {
                swSundaym.setText("Closed");
                llSundaym.setVisibility(View.GONE);
                llSundayClosedm.setVisibility(View.VISIBLE);
                loggedInRestaurant.sunday_status = "Close";
            }
        });

        swMondayE.setOnCheckedChangeListener((buttonView, isChecked) -> {
            if (isChecked) {
                swMondayE.setText("Open");
                llMondayE.setVisibility(View.VISIBLE);
                llMondayClosedE.setVisibility(View.GONE);
                loggedInRestaurant.monday_status = "";
            } else {
                swMondayE.setText("Closed");
                llMondayE.setVisibility(View.GONE);
                llMondayClosedE.setVisibility(View.VISIBLE);
                loggedInRestaurant.monday_status = "Close";
            }
        });
        swTuesdayE.setOnCheckedChangeListener((buttonView, isChecked) -> {
            if (isChecked) {
                swTuesdayE.setText("Open");
                llTuesdayE.setVisibility(View.VISIBLE);
                llTuesdayClosedE.setVisibility(View.GONE);
                loggedInRestaurant.tuesday_status = "";
            } else {
                swTuesdayE.setText("Closed");
                llTuesdayE.setVisibility(View.GONE);
                llTuesdayClosedE.setVisibility(View.VISIBLE);
                loggedInRestaurant.tuesday_status = "Close";
            }
        });

        swWednesdayE.setOnCheckedChangeListener((buttonView, isChecked) -> {
            if (isChecked) {
                swWednesdayE.setText("Open");
                llWednesdayE.setVisibility(View.VISIBLE);
                llWednesdayClosedE.setVisibility(View.GONE);
                loggedInRestaurant.wednesday_status = "";
            } else {
                swWednesdayE.setText("Closed");
                llWednesdayE.setVisibility(View.GONE);
                llWednesdayClosedE.setVisibility(View.VISIBLE);
                loggedInRestaurant.wednesday_status = "Close";
            }
        });

        swThursdayE.setOnCheckedChangeListener((buttonView, isChecked) -> {
            if (isChecked) {
                swThursdayE.setText("Open");
                llThursdayE.setVisibility(View.VISIBLE);
                llThursdayClosedE.setVisibility(View.GONE);
                loggedInRestaurant.thursday_status = "";
            } else {
                swThursdayE.setText("Closed");
                llThursdayE.setVisibility(View.GONE);
                llThursdayClosedE.setVisibility(View.VISIBLE);
                loggedInRestaurant.thursday_status = "Close";
            }
        });

        swFridayE.setOnCheckedChangeListener((buttonView, isChecked) -> {
            if (isChecked) {
                swFridayE.setText("Open");
                llFridayE.setVisibility(View.VISIBLE);
                llFridayClosedE.setVisibility(View.GONE);
                loggedInRestaurant.friday_status = "";
            } else {
                swFridayE.setText("Closed");
                llFridayE.setVisibility(View.GONE);
                llFridayClosedE.setVisibility(View.VISIBLE);
                loggedInRestaurant.friday_status = "Close";
            }
        });

        swSaturdayE.setOnCheckedChangeListener((buttonView, isChecked) -> {
            if (isChecked) {
                swSaturdayE.setText("Open");
                llSaturdayE.setVisibility(View.VISIBLE);
                llSaturdayClosedE.setVisibility(View.GONE);
                loggedInRestaurant.saturday_status = "";
            } else {
                swSaturdayE.setText("Closed");
                llSaturdayE.setVisibility(View.GONE);
                llSaturdayClosedE.setVisibility(View.VISIBLE);
                loggedInRestaurant.saturday_status = "Close";
            }
        });

        swSundayE.setOnCheckedChangeListener((buttonView, isChecked) -> {
            if (isChecked) {
                swSundayE.setText("Open");
                llSundayE.setVisibility(View.VISIBLE);
                llSundayClosedE.setVisibility(View.GONE);
                loggedInRestaurant.sunday_status = "Close";
            } else {
                swSundayE.setText("Closed");
                llSundayE.setVisibility(View.GONE);
                llSundayClosedE.setVisibility(View.VISIBLE);
                loggedInRestaurant.sunday_status = "Close";
            }
        });
        tvMondayFromM.setOnClickListener(v -> {
            //    fromPickerDialog(1);
            openTimeSlotBottomSheet("morning", true, 1);
        });
        tvTuesdayFromM.setOnClickListener(v -> {
            openTimeSlotBottomSheet("morning", true, 2);
        });
        tvWednesdayFromM.setOnClickListener(v -> {
            openTimeSlotBottomSheet("morning", true, 3);
        });
        tvThursdayFromM.setOnClickListener(v -> {
            openTimeSlotBottomSheet("morning", true, 4);
        });
        tvFridayFromM.setOnClickListener(v -> {
            openTimeSlotBottomSheet("morning", true, 5);
        });
        tvSaturdayFromM.setOnClickListener(v -> {
            openTimeSlotBottomSheet("morning", true, 6);
        });
        tvSundayFromM.setOnClickListener(v -> {
            openTimeSlotBottomSheet("morning", true, 7);
        });
        tvMondayToM.setOnClickListener(v -> {
            openTimeSlotBottomSheet("morning", false, 1);
        });
        tvTuesdayToM.setOnClickListener(v -> {
            openTimeSlotBottomSheet("morning", false, 2);
        });
        tvWednesdayToM.setOnClickListener(v -> {
            openTimeSlotBottomSheet("morning", false, 3);
        });
        tvThursdayToM.setOnClickListener(v -> {
            openTimeSlotBottomSheet("morning", false, 4);
        });
        tvFridayToM.setOnClickListener(v -> {
            openTimeSlotBottomSheet("morning", false, 5);
        });
        tvSaturdayToM.setOnClickListener(v -> {
            openTimeSlotBottomSheet("morning", false, 6);
        });
        tvSundayToM.setOnClickListener(v -> {
            openTimeSlotBottomSheet("morning", false, 7);
        });

        //Evening time
        tvMondayFromE.setOnClickListener(v -> {
            //    fromPickerDialog(1);
            openTimeSlotBottomSheet("evening", true, 1);
        });
        tvTuesdayFromE.setOnClickListener(v -> {
            openTimeSlotBottomSheet("evening", true, 2);
        });
        tvWednesdayFromE.setOnClickListener(v -> {
            openTimeSlotBottomSheet("evening", true, 3);
        });
        tvThursdayFromE.setOnClickListener(v -> {
            openTimeSlotBottomSheet("evening", true, 4);
        });
        tvFridayFromE.setOnClickListener(v -> {
            openTimeSlotBottomSheet("evening", true, 5);
        });
        tvSaturdayFromE.setOnClickListener(v -> {
            openTimeSlotBottomSheet("evening", true, 6);
        });
        tvSundayFromE.setOnClickListener(v -> {
            openTimeSlotBottomSheet("evening", true, 7);
        });
        tvMondayToE.setOnClickListener(v -> {
            openTimeSlotBottomSheet("evening", false, 1);
        });
        tvTuesdayToE.setOnClickListener(v -> {
            openTimeSlotBottomSheet("evening", false, 2);
        });
        tvWednesdayToE.setOnClickListener(v -> {
            openTimeSlotBottomSheet("evening", false, 3);
        });
        tvThursdayToE.setOnClickListener(v -> {
            openTimeSlotBottomSheet("evening", false, 4);
        });
        tvFridayToE.setOnClickListener(v -> {
            openTimeSlotBottomSheet("evening", false, 5);
        });
        tvSaturdayToE.setOnClickListener(v -> {
            openTimeSlotBottomSheet("evening", false, 6);
        });
        tvSundayToE.setOnClickListener(v -> {
            openTimeSlotBottomSheet("evening", false, 7);
        });

        llEveningTab.setOnClickListener(view1 -> {
            llEvening.setVisibility(View.VISIBLE);
            llMorning.setVisibility(View.GONE);
            vEvening.setVisibility(View.VISIBLE);
            vMorning.setVisibility(View.INVISIBLE);
        });
        llMorningTab.setOnClickListener(view1 -> {
            llMorning.setVisibility(View.VISIBLE);
            llEvening.setVisibility(View.GONE);
            vMorning.setVisibility(View.VISIBLE);
            vEvening.setVisibility(View.INVISIBLE);
        });

        btnUpdate.setOnClickListener(view1 -> {
            saveDetails();
        });

    }

    private void saveDetails() {
        try {
            if (getActivity() != null) {
                getActivity().runOnUiThread(() -> llLoading.setVisibility(View.VISIBLE));
            }

            AndroidNetworking.post(ApiEndPoints.restaurant_details + loggedInRestaurant.id)
                    .addApplicationJsonBody(loggedInRestaurant)
                    .build()
                    .getAsObject(Restaurant.class, new ParsedRequestListener<Restaurant>() {
                        @Override
                        public void onResponse(Restaurant response) {
                            try {
                                fetchProfile();
                                ToastUtils.makeLongToast(getActivity(), "Delivery hours updated!");
                                if (getActivity() != null) {
                                    getActivity().runOnUiThread(() -> {
                                        llLoading.setVisibility(View.GONE);
                                    });
                                }
                            } catch (Exception e) {
                                e.printStackTrace();
                            }
                        }

                        @Override
                        public void onError(ANError anError) {
                            try {
                                if (getActivity() != null) {
                                    getActivity().runOnUiThread(() -> {
                                        llLoading.setVisibility(View.GONE);
                                    });
                                }
                                if (anError.getErrorCode() == 400) {
                                    ToastUtils.makeToast(getActivity(), anError.getErrorAsObject(ApiError.class).getMessage());
                                }
                            } catch (Exception e) {
                                e.printStackTrace();
                            }
                        }
                    });
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void fetchProfile() {
        try {
            if (getActivity() != null) {
                getActivity().runOnUiThread(() -> llLoading.setVisibility(View.VISIBLE));
            }
            AndroidNetworking.get(ApiEndPoints.restaurant_details + loggedInRestaurant.id)
                    .build()
                    .getAsJSONObject(new JSONObjectRequestListener() {
                        @Override
                        public void onResponse(JSONObject response) {
                            try {
                                if (getActivity() != null) {
                                    getActivity().runOnUiThread(() -> llLoading.setVisibility(View.GONE));
                                }
                                myPreferences.saveRestaurant(response);
                                loggedInRestaurant = MyApp.getInstance().myPreferences.getRestaurant();
                                updateViews();
                            } catch (Exception e) {
                                e.printStackTrace();
                            }
                        }

                        @Override
                        public void onError(ANError anError) {
                            try {
                                anError.printStackTrace();
                                if (getActivity() != null) {
                                    getActivity().runOnUiThread(() -> llLoading.setVisibility(View.GONE));
                                }
                                if (anError.getErrorCode() == 400) {
                                    ToastUtils.makeToast(getActivity(), anError.getErrorAsObject(ApiError.class).getMessage());
                                }
                            } catch (Exception e) {
                                e.printStackTrace();
                            }
                        }
                    });
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void openTimeSlotBottomSheet(String daysTime, boolean fromSelected, int selectedDay) {
        try {
            OpeningHoursTimeSlotBottomSheetFragment slotBottomSheetFragment = OpeningHoursTimeSlotBottomSheetFragment.getInstance(daysTime);
            slotBottomSheetFragment.show(getChildFragmentManager(), "time_slots");
            slotBottomSheetFragment.setDialogDismissListener(o -> {
                String selectedTime = (String) o;

                setSelectedTime(daysTime, fromSelected, selectedDay, selectedTime);
            });
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void setSelectedTime(String dayTime, boolean fromSelected, int selectedDay, String selectedTime) {
        if (dayTime.equalsIgnoreCase("morning")) {
            if (fromSelected) {
                if (selectedDay == 1) {
                    if (findTimeRange(selectedTime, tvMondayToM.getText().toString())) {
                        tvMondayFromM.setText(selectedTime);
                        loggedInRestaurant.monday_first_opentime = selectedTime;
                    }
                } else if (selectedDay == 2) {
                    if (findTimeRange(selectedTime, tvTuesdayToM.getText().toString())) {
                        tvTuesdayFromM.setText(selectedTime);
                        loggedInRestaurant.tuesday_first_opentime = selectedTime;
                    }
                } else if (selectedDay == 3) {
                    if (findTimeRange(selectedTime, tvWednesdayToM.getText().toString())) {
                        tvWednesdayFromM.setText(selectedTime);
                        loggedInRestaurant.wednesday_first_opentime = selectedTime;
                    }
                } else if (selectedDay == 4) {
                    if (findTimeRange(selectedTime, tvThursdayToM.getText().toString())) {
                        tvThursdayFromM.setText(selectedTime);
                        loggedInRestaurant.thursday_first_opentime = selectedTime;
                    }
                } else if (selectedDay == 5) {
                    if (findTimeRange(selectedTime, tvFridayToM.getText().toString())) {
                        tvFridayFromM.setText(selectedTime);
                        loggedInRestaurant.friday_first_opentime = selectedTime;
                    }
                } else if (selectedDay == 6) {
                    if (findTimeRange(selectedTime, tvSaturdayToM.getText().toString())) {
                        tvSaturdayFromM.setText(selectedTime);
                        loggedInRestaurant.saturday_first_opentime = selectedTime;
                    }
                } else if (selectedDay == 7) {
                    if (findTimeRange(selectedTime, tvSundayToM.getText().toString())) {
                        tvSundayFromM.setText(selectedTime);
                        loggedInRestaurant.sunday_first_opentime = selectedTime;
                    }
                }
            } else {
                if (selectedDay == 1) {
                    if (findTimeRange(tvMondayFromM.getText().toString(), selectedTime)) {
                        tvMondayToM.setText(selectedTime);
                        loggedInRestaurant.monday_first_closetime = selectedTime;
                    }
                } else if (selectedDay == 2) {
                    if (findTimeRange(tvTuesdayFromM.getText().toString(), selectedTime)) {
                        tvTuesdayToM.setText(selectedTime);
                        loggedInRestaurant.tuesday_first_closetime = selectedTime;
                    }
                } else if (selectedDay == 3) {
                    if (findTimeRange(tvWednesdayFromM.getText().toString(), selectedTime)) {
                        tvWednesdayToM.setText(selectedTime);
                        loggedInRestaurant.wednesday_first_closetime = selectedTime;
                    }
                } else if (selectedDay == 4) {
                    if (findTimeRange(tvThursdayFromM.getText().toString(), selectedTime)) {
                        tvThursdayToM.setText(selectedTime);
                        loggedInRestaurant.thursday_first_closetime = selectedTime;
                    }
                } else if (selectedDay == 5) {
                    if (findTimeRange(tvFridayFromM.getText().toString(), selectedTime)) {
                        tvFridayToM.setText(selectedTime);
                        loggedInRestaurant.friday_first_closetime = selectedTime;
                    }
                } else if (selectedDay == 6) {
                    if (findTimeRange(tvSaturdayFromM.getText().toString(), selectedTime)) {
                        tvSaturdayToM.setText(selectedTime);
                        loggedInRestaurant.saturday_first_closetime = selectedTime;
                    }
                } else if (selectedDay == 7) {
                    if (findTimeRange(tvSundayFromM.getText().toString(), selectedTime)) {
                        tvSundayToM.setText(selectedTime);
                        loggedInRestaurant.sunday_first_closetime = selectedTime;
                    }
                }
            }
        } else if (dayTime.equalsIgnoreCase("evening")) {
            if (fromSelected) {
                if (selectedDay == 1) {
                    if (findTimeRange(selectedTime, tvMondayToE.getText().toString())) {
                        tvMondayFromE.setText(selectedTime);
                        loggedInRestaurant.monday_second_opentime = selectedTime;
                    }
                } else if (selectedDay == 2) {
                    if (findTimeRange(selectedTime, tvTuesdayToE.getText().toString())) {
                        tvTuesdayFromE.setText(selectedTime);
                        loggedInRestaurant.tuesday_second_opentime = selectedTime;
                    }
                } else if (selectedDay == 3) {
                    if (findTimeRange(selectedTime, tvWednesdayToE.getText().toString())) {
                        tvWednesdayFromE.setText(selectedTime);
                        loggedInRestaurant.wednesday_second_opentime = selectedTime;
                    }
                } else if (selectedDay == 4) {
                    if (findTimeRange(selectedTime, tvThursdayToE.getText().toString())) {
                        tvThursdayFromE.setText(selectedTime);
                        loggedInRestaurant.thursday_second_opentime = selectedTime;
                    }
                } else if (selectedDay == 5) {
                    if (findTimeRange(selectedTime, tvFridayToE.getText().toString())) {
                        tvFridayFromE.setText(selectedTime);
                        loggedInRestaurant.friday_second_opentime = selectedTime;
                    }
                } else if (selectedDay == 6) {
                    if (findTimeRange(selectedTime, tvSaturdayToE.getText().toString())) {
                        tvSaturdayFromE.setText(selectedTime);
                        loggedInRestaurant.saturday_second_opentime = selectedTime;
                    }
                } else if (selectedDay == 7) {
                    if (findTimeRange(selectedTime, tvSundayToE.getText().toString())) {
                        tvSundayFromE.setText(selectedTime);
                        loggedInRestaurant.sunday_second_opentime = selectedTime;
                    }
                }
            } else {
                if (selectedDay == 1) {
                    if (findTimeRange(tvMondayFromE.getText().toString(), selectedTime)) {
                        tvMondayToE.setText(selectedTime);
                        loggedInRestaurant.monday_second_closetime = selectedTime;
                    }
                } else if (selectedDay == 2) {
                    if (findTimeRange(tvTuesdayFromE.getText().toString(), selectedTime)) {
                        tvTuesdayToE.setText(selectedTime);
                        loggedInRestaurant.tuesday_second_closetime = selectedTime;
                    }
                } else if (selectedDay == 3) {
                    if (findTimeRange(tvWednesdayFromE.getText().toString(), selectedTime)) {
                        tvWednesdayToE.setText(selectedTime);
                        loggedInRestaurant.wednesday_second_closetime = selectedTime;
                    }
                } else if (selectedDay == 4) {
                    if (findTimeRange(tvThursdayFromE.getText().toString(), selectedTime)) {
                        tvThursdayToE.setText(selectedTime);
                        loggedInRestaurant.thursday_second_closetime = selectedTime;
                    }
                } else if (selectedDay == 5) {
                    if (findTimeRange(tvFridayFromE.getText().toString(), selectedTime)) {
                        tvFridayToE.setText(selectedTime);
                        loggedInRestaurant.friday_second_closetime = selectedTime;
                    }
                } else if (selectedDay == 6) {
                    if (findTimeRange(tvSaturdayFromE.getText().toString(), selectedTime)) {
                        tvSaturdayToE.setText(selectedTime);
                        loggedInRestaurant.saturday_second_closetime = selectedTime;
                    }
                } else if (selectedDay == 7) {
                    if (findTimeRange(tvSundayFromE.getText().toString(), selectedTime)) {
                        tvSundayToE.setText(selectedTime);
                        loggedInRestaurant.sunday_second_closetime = selectedTime;
                    }
                }
            }
        }


        updateViews();

    }

    private boolean findTimeRange(String from_time, String to_time) {
        SimpleDateFormat dateFormat = new SimpleDateFormat("hh:mm a");
        try {
            fromDate = dateFormat.parse(from_time);
            toDate = dateFormat.parse(to_time);
        } catch (ParseException e) {
            e.printStackTrace();
        }
        if (fromDate.getTime() > toDate.getTime()) {
            ToastUtils.makeToast(getActivity(), "Invalid time range");
            return false;
        }

        return true;
    }

    private void fromPickerDialog(int selectedDay) {
        TimePickerDialog timePickerDialog = new TimePickerDialog(getActivity(), (view, hour, minute) -> {
            fromCalendar.set(Calendar.HOUR_OF_DAY, hour);
            fromCalendar.set(Calendar.MINUTE, minute);

            fromDate = fromCalendar.getTime();
            fromSelectedDay = CommonFunctions.formatMiliToDesireFormat(fromDate.getTime(), "hh:mm a");
            if (selectedDay == 1) {
                tvMondayFromM.setText(fromSelectedDay);
            } else if (selectedDay == 2) {
                tvTuesdayFromM.setText(fromSelectedDay);
            } else if (selectedDay == 3) {
                tvWednesdayFromM.setText(fromSelectedDay);
            } else if (selectedDay == 4) {
                tvThursdayFromM.setText(fromSelectedDay);
            } else if (selectedDay == 5) {
                tvFridayFromM.setText(fromSelectedDay);
            } else if (selectedDay == 6) {
                tvSaturdayFromM.setText(fromSelectedDay);
            } else if (selectedDay == 7) {
                tvSundayFromM.setText(fromSelectedDay);
            }
        }, fromCalendar.get(Calendar.HOUR_OF_DAY), fromCalendar.get(Calendar.MINUTE), false);
        timePickerDialog.show();
        timePickerDialog.setOnCancelListener(dialogInterface -> {

        });
    }

    private void toPickerDialog(int selectedDay) {
        TimePickerDialog timePickerDialog = new TimePickerDialog(getActivity(), (view, hour, minute) -> {
            toCalendar.set(Calendar.HOUR_OF_DAY, hour);
            toCalendar.set(Calendar.MINUTE, minute);

            toDate = toCalendar.getTime();
            toSelectedDay = CommonFunctions.formatMiliToDesireFormat(toDate.getTime(), "hh:mm a");
            if (selectedDay == 1) {
                tvMondayToM.setText(fromSelectedDay);
            } else if (selectedDay == 2) {
                tvTuesdayToM.setText(fromSelectedDay);
            } else if (selectedDay == 3) {
                tvWednesdayToM.setText(fromSelectedDay);
            } else if (selectedDay == 4) {
                tvThursdayToM.setText(fromSelectedDay);
            } else if (selectedDay == 5) {
                tvFridayToM.setText(fromSelectedDay);
            } else if (selectedDay == 6) {
                tvSaturdayToM.setText(fromSelectedDay);
            } else if (selectedDay == 7) {
                tvSundayToM.setText(fromSelectedDay);
            }
        }, toCalendar.get(Calendar.HOUR_OF_DAY), toCalendar.get(Calendar.MINUTE), false);
        timePickerDialog.show();
        timePickerDialog.setOnCancelListener(dialogInterface -> {

        });

    }

    private void initViews(View view) {
        progressBarDialog = CommonFunctions.customProgressDialog(getActivity());
        llMondaym = view.findViewById(R.id.MorningllMonday);
        llTuesdaym = view.findViewById(R.id.MorningllTuesday);
        llWednesdaym = view.findViewById(R.id.MorningllWednesday);
        llThursdaym = view.findViewById(R.id.MorningllThursday);
        llFridaym = view.findViewById(R.id.MorningllFriday);
        llSaturdaym = view.findViewById(R.id.MorningllSaturday);
        llSundaym = view.findViewById(R.id.MorningllSunday);


        llMondayE = view.findViewById(R.id.EveningllMonday);
        llTuesdayE = view.findViewById(R.id.EveningllTuesday);
        llWednesdayE = view.findViewById(R.id.EveningllWednesday);
        llThursdayE = view.findViewById(R.id.EveningllThursday);
        llFridayE = view.findViewById(R.id.EveningllFriday);
        llSaturdayE = view.findViewById(R.id.EveningllSaturday);
        llSundayE = view.findViewById(R.id.EveningllSunday);

        llMondayClosedm = view.findViewById(R.id.MorningllMClosed);
        llTuesdayClosedm = view.findViewById(R.id.MorningllTueClosed);
        llWednesdayClosedm = view.findViewById(R.id.MorningllWedClosed);
        llThursdayClosedm = view.findViewById(R.id.MorningllThClosed);
        llFridayClosedm = view.findViewById(R.id.MorningllFriClosed);
        llSaturdayClosedm = view.findViewById(R.id.MorningllSatClosed);
        llSundayClosedm = view.findViewById(R.id.MorningllSunClosed);

        llMondayClosedE = view.findViewById(R.id.EveningllMClosed);
        llTuesdayClosedE = view.findViewById(R.id.EveningllTueClosed);
        llWednesdayClosedE = view.findViewById(R.id.EveningllWedClosed);
        llThursdayClosedE = view.findViewById(R.id.EveningllThClosed);
        llFridayClosedE = view.findViewById(R.id.EveningllFriClosed);
        llSaturdayClosedE = view.findViewById(R.id.EveningllSatClosed);
        llSundayClosedE = view.findViewById(R.id.EveningllSunClosed);

        swMondaym = view.findViewById(R.id.MorningswMonday);
        swTuesdaym = view.findViewById(R.id.MorningswTuesday);
        swWednesdaym = view.findViewById(R.id.MorningswWednesday);
        swThursdaym = view.findViewById(R.id.MorningswThursday);
        swFridaym = view.findViewById(R.id.MorningswFriday);
        swSaturdaym = view.findViewById(R.id.MorningswSaturday);
        swSundaym = view.findViewById(R.id.MorningswSunday);

        swMondayE = view.findViewById(R.id.EveningswMonday);
        swTuesdayE = view.findViewById(R.id.EveningswTuesday);
        swWednesdayE = view.findViewById(R.id.EveningswWednesday);
        swThursdayE = view.findViewById(R.id.EveningswThursday);
        swFridayE = view.findViewById(R.id.EveningswFriday);
        swSaturdayE = view.findViewById(R.id.EveningswSaturday);
        swSundayE = view.findViewById(R.id.EveningswSunday);

        tvMondayFromM = view.findViewById(R.id.MorningtvMonFrom);
        tvTuesdayFromM = view.findViewById(R.id.MorningtvTueFrom);
        tvWednesdayFromM = view.findViewById(R.id.MorningtvWedFrom);
        tvThursdayFromM = view.findViewById(R.id.MorningtvThuFrom);
        tvFridayFromM = view.findViewById(R.id.MorningtvFriFrom);
        tvSaturdayFromM = view.findViewById(R.id.MorningtvSatFrom);
        tvSundayFromM = view.findViewById(R.id.MorningtvSunFrom);

        tvMondayToM = view.findViewById(R.id.MorningtvMonTo);
        tvTuesdayToM = view.findViewById(R.id.MorningtvTueTo);
        tvWednesdayToM = view.findViewById(R.id.MorningtvWedTo);
        tvThursdayToM = view.findViewById(R.id.MorningtvThuTo);
        tvFridayToM = view.findViewById(R.id.MorningtvFriTo);
        tvSaturdayToM = view.findViewById(R.id.MorningtvSatTo);
        tvSundayToM = view.findViewById(R.id.MorningtvSunTo);


        tvMondayFromE = view.findViewById(R.id.EveningtvMonFrom);
        tvTuesdayFromE = view.findViewById(R.id.EveningtvTueFrom);
        tvWednesdayFromE = view.findViewById(R.id.EveningtvWedFrom);
        tvThursdayFromE = view.findViewById(R.id.EveningtvThuFrom);
        tvFridayFromE = view.findViewById(R.id.EveningtvFriFrom);
        tvSaturdayFromE = view.findViewById(R.id.EveningtvSatFrom);
        tvSundayFromE = view.findViewById(R.id.EveningtvSunFrom);

        tvMondayToE = view.findViewById(R.id.EveningtvMonTo);
        tvTuesdayToE = view.findViewById(R.id.EveningtvTueTo);
        tvWednesdayToE = view.findViewById(R.id.EveningtvWedTo);
        tvThursdayToE = view.findViewById(R.id.EveningtvThuTo);
        tvFridayToE = view.findViewById(R.id.EveningtvFriTo);
        tvSaturdayToE = view.findViewById(R.id.EveningtvSatTo);
        tvSundayToE = view.findViewById(R.id.EveningtvSunTo);

        btnUpdate = view.findViewById(R.id.btnUpdate);
        llMorningTab = view.findViewById(R.id.llMorningTab);
        llEveningTab = view.findViewById(R.id.llEveningTab);

        llMorning = view.findViewById(R.id.MorningllMorning);
        llEvening = view.findViewById(R.id.EveningllEvening);

        vMorning = view.findViewById(R.id.vMorning);
        vEvening = view.findViewById(R.id.vEvening);
        chipBack = view.findViewById(R.id.chipBack);
        llLoading = view.findViewById(R.id.llLoading);
    }
}
